package com.diagbot.facade;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.biz.push.entity.Lis;
import com.diagbot.biz.push.entity.Pacs;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.BillProcess;
import com.diagbot.vo.BillNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 开单合理性facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class BillFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    BillProcess billProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 开单合理性业务
     * @param
     * @return
     */
    public void billFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 开单合理性图谱接口调用
        BillNeoVO billNeoVO = fillBillNeo(wordCrfDTO);

        List<BillNeoDTO> billNeoDTOList = neoFacade.getBillNeo(billNeoVO);

        // 获取药品缓存信息，现在不用
        // neoFacade.getDrugCache();

        // 规则开发
       billProcess.process(billNeoDTOList, wordCrfDTO, res);
    }


    public BillNeoVO fillBillNeo(WordCrfDTO wordCrfDTO) {
        BillNeoVO billNeoVO = new BillNeoVO();

        List<Item> items = wordCrfDTO.getDrugOrder();

        for (Item item : items) {
            billNeoVO.getDrugList().put(item.getName(), item.getUniqueName());
        }

        List<Pacs> pacslist = wordCrfDTO.getPacsOrder();
        for (Pacs pacs : pacslist) {
            billNeoVO.getPacsList().put(pacs.getName(), pacs.getUniqueName());
        }

        List<Lis> lislist = wordCrfDTO.getLisOrder();
        for (Lis lis : lislist) {
            billNeoVO.getLisList().put(lis.getName(), lis.getUniqueName());
        }

        List<Item> diags = wordCrfDTO.getDiagOrder();
        for (Item item : diags) {
            billNeoVO.getDiagList().put(item.getName(), item.getUniqueName());
        }

        return billNeoVO;
    }
}
