package com.diagbot.facade;

import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.vo.IndicationPushVO;
import com.diagbot.vo.StandConvert;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @Description: 提示信息facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class IndicationFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    CommonFacade commonFacade;
    @Autowired
    BillFacade billFacade;

    /**
     * 病情提示总入口
     *
     * @param
     * @return
     */
    public IndicationDTO indicationFac(IndicationPushVO indicationPushVO) {
        IndicationDTO res = new IndicationDTO();
        // 模型处理数据
        WordCrfDTO wordCrfDTO = commonFacade.crf_process(indicationPushVO);

        // 标准词转换
        StandConvert standConvert = commonFacade.dataTypeGet(wordCrfDTO);
        Map<Integer, Map<String, String>> standConvertMap = neoFacade.standConvert(standConvert);
        commonFacade.dataTypeSet(wordCrfDTO, standConvertMap);

        List<String> ruleTypeList = Arrays.asList(indicationPushVO.getRuleType().split(","));

        // 开单合理性
        if (ruleTypeList.contains("2")) {
            billFacade.billFac(indicationPushVO, wordCrfDTO, res);
        }

        // TODO 其他类型提示
        return res;
    }
}
