package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.CoreUtil;

/**
 * @description: 年龄规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
public class AgeRule {

    /**
     * 年龄比较
     *
     * @param wordCrfDTO
     * @param billNeoMaxDTO
     * @return
     */
    public static BillMsg compareAgeWithBill(WordCrfDTO wordCrfDTO, BillNeoMaxDTO billNeoMaxDTO) {
        NodeNeoDTO ageNeoDTO = billNeoMaxDTO.getAgeNeoDTO();
        Boolean flag = false;
        if (ageNeoDTO != null && wordCrfDTO.getAge() != null) {
            Integer age = wordCrfDTO.getAge();
            flag = CoreUtil.compareNum(ageNeoDTO, age);
        }
        if (flag) {
            return CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                    String.valueOf(wordCrfDTO.getAge() + "岁"), String.valueOf(wordCrfDTO.getAge() + "岁"));
        }
        return null;
    }
}
