package com.diagbot.rule;

import com.diagbot.biz.push.entity.Lis;
import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.ListUtil;
import com.diagbot.util.StringUtil;
import org.apache.commons.lang3.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @description: 化验规则
 * @author: kwz
 * @time: 2020/8/3 14:47
 */
public class LisRule {

    /**
     * 比较化验
     *
     * @param inputLis
     * @param billNeoMaxDTO
     * @return
     */
    public static BillMsg compareLisWithBill(List<Lis> inputLis, BillNeoMaxDTO billNeoMaxDTO) {
        List<String> msgList = new ArrayList<>();
        List<NodeNeoDTO> neoList = billNeoMaxDTO.getLis();
        if(ListUtil.isNotEmpty(neoList) && ListUtil.isNotEmpty(inputLis)){
            for (NodeNeoDTO neo : neoList) {
                for (Lis lis : inputLis) {
                    String val = lis.getUniqueName();
                    if (StringUtil.isNotBlank(val) && neo.getName().equals(val)) {
                        String val_name = lis.getDetailName();
                        // 如果有结果数据，就不用比较数值
                        if (StringUtil.isNotBlank(lis.getResult())) {
                            boolean flag = CoreUtil.compareStr(neo, lis.getResult());
                            if (flag) {
                                msgList.add(CoreUtil.getStrMsg(neo, val_name, lis.getResult()));
                            }
                        } else if (lis.getValue() != null) {
                            boolean flag = CoreUtil.compareNum(neo, lis.getValue());
                            if (flag) {
                                msgList.add(CoreUtil.getNumMsg(neo, val_name, lis.getValue(), lis.getUnits()));
                            }
                        }
                    }
                }
            }
        }
        if (ListUtil.isNotEmpty(msgList)){
           String message = StringUtils.join(msgList, ",");
            BillMsg commonBillMsg = CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(),billNeoMaxDTO.getOrderStandName(),message,null);
            return commonBillMsg;
        }
        return null;
    }
}
