package com.diagbot.rule;

import com.diagbot.dto.BillMsg;
import com.diagbot.dto.BillNeoMaxDTO;
import com.diagbot.dto.NodeNeoDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.util.CoreUtil;
import com.diagbot.util.StringUtil;

/**
 * @description: 性别规则
 * @author: zhoutg
 * @time: 2020/8/3 14:47
 */
public class SexRule {

    /**
     * 比较性别
     *
     * @param wordCrfDTO
     * @param billNeoMaxDTO
     * @return
     */
    public static BillMsg compareSexWithBill(WordCrfDTO wordCrfDTO, BillNeoMaxDTO billNeoMaxDTO) {
        NodeNeoDTO nodeNeoDTO = billNeoMaxDTO.getGender();
        if (nodeNeoDTO != null && StringUtil.isNotBlank(nodeNeoDTO.getName()) && wordCrfDTO.getSex() != null) {
            String sex = nodeNeoDTO.getName();
            String sexStr = "";
            if (1 == wordCrfDTO.getSex()) {
                sexStr = "男";
            } else if (2 == wordCrfDTO.getSex()) {
                sexStr = "女";
            }
            if (sex.equals(sexStr)) {
                if ("男".equals(sexStr)) {
                    return CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                            "男性", "男性");
                } else if ("女".equals(sexStr)) {
                    return CoreUtil.getCommonBillMsg(billNeoMaxDTO.getOrderName(), billNeoMaxDTO.getOrderStandName(),
                            "女性", "女性");
                }
            }
        }
        return null;
    }
}
